unit kemousb;

interface

const
//<dbt.h>
DBT_DEVICEARRIVAL      =  $8000;

//firmware constants
//;command_type constants (from host to device)
CMD_SET_PORTS          =  00;   //; 2 params: data port 0 and 1
CMD_SET_PULLUPS        =  01;   //; 2 params: pullup register port 0 and 1
CMD_SET_REGISTER       =  02;   //; 2 params: register adr and value
CMD_SET_MEMORY         =  03;   //; 2 params: memory pointer and value
CMD_SET_REPORT_TYPE    =  04;   //; 2 params: report type and pointer
CMD_ENABLE_INTERRUPT   =  05;   //; 1 param: mask of interrupt (0x02 for microtimer)
CMD_DISABLE_INTERRUPT  =  06;   //; 1 param: mask of interrupt (0x02 for microtimer)

CMD_CLEAR_COMMANDLIST  =  07;   //; no params
CMD_CLEAR_MOTOR1       = $17;   //no params
CMD_CLEAR_MOTOR2       = $27;   //no params
CMD_CLEAR_MOTOR3       = $37;   //no params
CMD_CLEAR_MOTOR4       = $47;   //no params

CMD_DO_NOTHING         =  08;   //; for connection test
CMD_ADD_CMD1           = $10;   //; 3 params: (tick_L8)(tick_H6,D,S)[repeat cnt]
CMD_ADD_CMD2           = $20;   //; M2
CMD_ADD_CMD3           = $30;   //; M3
CMD_ADD_CMD4           = $40;   //; M4

CMD_START_RESET        = $09;   //; motormask,
CMD_SET_STATE          = $0A;   //; set state for port1 with mask

//;report_type constants  (device to host)
REPORT_NONE            =  0;
OBSOLOTE_LASTCMDTICK   =  01;   //; no params
REPORT_PORTSTUFF       =  02;   //; no params
REPORT_VARIABLES       =  03;   //; param pointer into memory
REPORT_CURRENTTICK     =  04;   //; no params
REPORT_MOTOR_STATUS    =  05;   // out: port0,port1,m1.nextfree,m2.nextfree,m3.nextfree,m4.nextfree

CMDLISTSIZE            =  12;   // 14-2 byte for each motor

//cy7c63101 io ports
PORT0_Data             = $00;   // ; GPIO data port 0
PORT1_Data             = $01;   // ; GPIO data port 1
PORT0_Interrupt        = $04;   // ; Interrupt enable for port 0
PORT1_Interrupt        = $05;   // ; Interrupt enable for port 1
PORT0_Pullup           = $08;   // ; Pullup resistor control for port 0
PORT1_Pullup           = $09;   // ; Pullup resistor control for port 1

//device variable address
MotorResetFlags        = $13;


type
  PHIDP_CAPS = ^HIDP_CAPS;
  HIDP_CAPS = packed record
    Usage:                      WORD;
    UsagePage:                  WORD;
    InputReportByteLength:      WORD;
    OutputReportByteLength:     WORD;
    FeatureReportByteLength:    WORD;
    Reserved: array[0..16]of    WORD;

    NumberLinkCollectionNodes:  WORD;

    NumberInputButtonCaps:      WORD;
    NumberInputValueCaps:       WORD;
    NumberInputDataIndices:     WORD;

    NumberOutputButtonCaps:     WORD;
    NumberOutputValueCaps:      WORD;
    NumberOutputDataIndices:    WORD;

    NumberFeatureButtonCaps:    WORD;
    NumberFeatureValueCaps:     WORD;
    NumberFeatureDataIndices:   WORD;
  end;

  PPSP_INTERFACE_DEVICE_DETAIL_DATA = ^PSP_INTERFACE_DEVICE_DETAIL_DATA;
  PSP_INTERFACE_DEVICE_DETAIL_DATA = ^SP_INTERFACE_DEVICE_DETAIL_DATA;
  SP_INTERFACE_DEVICE_DETAIL_DATA=packed record
    cbSize: cardinal;
    DevicePath: array[0..1019]of char; // this does not quite match the declaration in the ddk (which defines a zero length array)
  end;

  TKemoUsb_FindDevice = function(VendorID: integer;ProductID: integer; PdetailData: PSP_INTERFACE_DEVICE_DETAIL_DATA; DeviceCaps: PHIDP_CAPS):boolean; stdcall;

implementation

end.
 